/* grout : 24mar2k : aempirei : ssg : chrisa@csanetworks.com */

#include "gt.h"
#include "inetraw.h"

S geography
{
   S in_addr r_ip;
   S geo r_geo;
}
 *global_routed;		/* too bad i made this global, but theres a
				   local one. i dont use this unless i have
				   to, like in the signal handler */

void title (void);
void usage (char *);

void *thread_trace (void *);

void sig_int (int);
void display_route (S geography *, int);

#define HOPS 32

/*posix thread variables for mutex locks and such */
pthread_t ptidsig;
pthread_mutex_t ptidsig_mutex = PTHREAD_MUTEX_INITIALIZER;
pthread_cond_t ptidsig_cond = PTHREAD_COND_INITIALIZER;

int mode = 0,			/* display mode from options */
  alive = 0;			/* target response : this is stupid to be
				   global, but hey. */
int
main (int argc, char **argv)
{
   S utsname hinfo;
   S rawifconf rif;
   int i, j, timeout = 5;
   char c;
   time_t t;
   S ip ip_p;
   pthread_t ptid;
   S timeval timev;
   S timespec pt_ts;

   S geography routed[HOPS];	/* stores route information for each hop */

   char packet[512];
   S icmp *icmp_hdr = (S icmp *) packet;

   extern int optind;
   extern char *optarg;

   global_routed = routed;

   bzero (routed, SO (routed));
   bzero (&rif, SO (rif));
   setvbuf (stdout, NULL, _IONBF, 0);

   title ();			/* display program banner */

   while ((c = getopt (argc, argv, "ai:t:")) != -1) {
      switch (c) {
      case 'i':		/* specify interface */
	 strncpy (rif.ri_if, optarg, IFNAMSIZE - 1);
	 break;
      case 'a':		/* alternate display mode */
	 mode = 1;
	 break;
      case 't':		/* alternate timeout */
	 timeout = atoi (optarg);
	 break;
      case '?':		/* unknown option */
	 usage (*argv);
	 break;
      }
   }

   if (argc - optind != 1)	/* make sure a target argument exists */
      usage (*argv);

   uname (&hinfo);		/* fetch machine info */

   /* display machine info */
   printf ("\n- '%s' running %s %s %s\n",
	   hinfo.nodename, hinfo.sysname, hinfo.release, hinfo.machine);
   /* make sure target exists */
   if (!ipv4_rslvhost (argv[optind], &rif.ri_dst))
      exit (printf ("- error: target '%s' not found\n", argv[optind]));

   setuid (0);			/* root uid only */

   if (getuid ())
      exit (printf
	    ("- error: %s does not have root privilages\n", getlogin ()));

   signal (SIGINT, &sig_int);

   /* initialize packet device structure */
   if (init_packet_devices (&rif))
      exit (printf ("error: cannot initialize packet devices\n"));

   /* tell us who we're tracing */
   printf ("- routing %s on %s:", ipv4_showname (rif.ri_dst), rif.ri_if);
   printf ("%s\n", ipv4_showname (rif.ri_src));

#define ICMP_PACKET_TYPE ICMP_ECHO
   for (i = j = 0; i < HOPS; i++) {	/* send 2 ICMP ECHOS per TTL */
      if (sendicmp (&rif, ICMP_PACKET_TYPE, 0, i, i + 1))
	 perror ("sendicmp()");
      if (sendicmp (&rif, ICMP_PACKET_TYPE, 0, i, i + 1))
	 perror ("sendicmp()");
   }

   t = time (NULL);

   while (time (NULL) - t < timeout) {	/* wait for responses for a little
					   while */
      printf ("- time left (%d)  \r", timeout + t - time (NULL));	/* cute 
									   count-down */
      if (get_packet (&rif, &ip_p, packet, SO (packet), CHK_SOURCE_IP))
	 continue;		/* check if we have a packet on the line */
#define icmp_embed_hdr(a)\
   (*(S icmp *)(((a)->icmp_data)+((a)->icmp_ip.ip_hl*4)))
      /* if the packet matches a router's packet expired resp. then log it */
      if (ip_p.ip_p == IPPROTO_ICMP &&
	  icmp_hdr->icmp_type == ICMP_TIMXCEED &&
	  icmp_hdr->icmp_code == ICMP_TIMXCEED_INTRANS &&
	  icmp_hdr->icmp_ip.ip_id == getpid () &&
	  icmp_embed_hdr (icmp_hdr).icmp_type == ICMP_PACKET_TYPE) {
	 i = icmp_embed_hdr (icmp_hdr).icmp_seq;	/* i is the hop # */
	 if (routed[i].r_ip.s_addr)
	    continue;		/* if we logged this hop already, then skip
				   it */
	 routed[i].r_ip.s_addr = ip_p.ip_src.s_addr;	/* set the hop's ip */
	 if (!pthread_create (&ptid, NULL, thread_trace, &routed[i]))
	    j++;		/* create a thread to get geo. information
				   and increment the thread count */
      } else if (ip_p.ip_p == IPPROTO_ICMP	/* maybe it was the target
						   who responded */
		 &&
		 ((ip_p.ip_src.s_addr == rif.ri_dst.s_addr
		   && icmp_hdr->icmp_type == ICMP_ECHOREPLY)
		  || icmp_hdr->icmp_type == ICMP_UNREACH)) {
	 alive = icmp_hdr->icmp_type + 1;	/* we'll set the response of
						   the target, also */
	 break;			/* we got a response from the target, so we
				   can quit waiting because we should have
				   gotten all the expires already too */
      }
   }

   printf ("- time left (done) \n");

   while (j) {			/* process cleanup, wait for the threads to
				   quit. */
      printf ("- process cleanup (%d)  \r", j--);

      pthread_mutex_lock (&ptidsig_mutex);

      gettimeofday (&timev, NULL);
      pt_ts.tv_sec = timev.tv_sec + 4;
      pt_ts.tv_nsec = timev.tv_usec * 1000;

      /* threads have a habit of signaling before we get done with the
         capture loop up there because this is fast program of course :) so
         we set a 4 second time limit on the conditional waiting */
      pthread_cond_timedwait (&ptidsig_cond, &ptidsig_mutex, &pt_ts);

      pthread_mutex_unlock (&ptidsig_mutex);
   }

   printf ("- process cleanup (done) \n");

   display_route (routed, HOPS);	/* show what we know */

   term_packet_devices (&rif);	/* terminate the packet device structure */

   return (0);
}

void
title (void)
{
   int i, j;
   /* very cute centering technique */
   for (i = 0; i < 78; i++)
      putchar ('*');
   putchar ('\n');
   i = (78 - SO (SSG " " VERSION " " AUTHORS " " SSG)) >> 1;
   for (j = 0; j <= i; j++)
      putchar (' ');
   puts (SSG " " VERSION " " AUTHORS " " SSG);
   for (i = 0; i < 78; i++)
      putchar ('*');
   putchar ('\n');
}

void
usage (char *prog)
{
   printf ("\nusage %s: [options] <target>\n", prog);
   printf ("   -a       \talternative display mode\n"
	   "   -i device\tuse specified interface\n"
	   "   -t seconds\ttime to wait for all responses\n\n");
   exit (EXIT_FAILURE);
}

/*this calls the tracing routine for geo. lookup, check gt-parse.c */
void *
thread_trace (void *arg)
{
   S geography *route = arg;
   trace (route->r_ip, &route->r_geo);

   pthread_mutex_lock (&ptidsig_mutex);
   ptidsig = pthread_self ();
   pthread_cond_signal (&ptidsig_cond);
   pthread_mutex_unlock (&ptidsig_mutex);

   return (NULL);
}

/*the title says all*/
void
display_route (S geography * routed, int max_r)
{
   int i;
   for (i = 0; i < max_r; i++) {
      if (routed[i].r_ip.s_addr) {
	 if (!mode) {
	    printf (*routed[i].r_geo.name ?
		    "%2i %-15s %2.2s %-27.27s %-28.28s\n" :
		    "%2i %-15s ** *\n", i + 1,
		    inet_ntoa (routed[i].r_ip),
		    routed[i].r_geo.country,
		    routed[i].r_geo.location, routed[i].r_geo.name);
	 } else {
	    if (i == 0
		|| memcmp (&routed[i - 1].r_geo, &routed[i].r_geo,
			   SO (S geo))) {
	       printf (*routed[i].
		       r_geo.name ? "%2.2s  %.*s  %.*s\n" : "**  *\n",
		       routed[i].r_geo.country, GLLOC,
		       routed[i].r_geo.location, GLNAM, routed[i].r_geo.name);
	    }
	    printf ("\t%2i : %-15s  %s\n", i + 1, inet_ntoa (routed[i].r_ip),
		    ipv4_showname (routed[i].r_ip));
	 }
      }
   }
}

/*interrrupt signal handler*/
void
sig_int (int signo)
{
   signal (SIGINT, SIG_IGN);

   printf ("\n- signal caught: interrupt\n");
   printf ("- displaying incomplete route\n");

   display_route (global_routed, HOPS);

   exit (EXIT_FAILURE);
}
