/* grout parsing routines : 24mar2k : chrisa@csanetworks.com */

#include "gt.h"

#define US_STYLE 0
#define UK_STYLE 1
#define lastchr(a) a[strlen(a) - 1]
char *rmspace (char *);

/* trace the ip address to a location */
int
trace (S in_addr ipaddr, S geo * gp)
{
   SAin sa;
   int sd, i, j;
   char string[18], buf[STD_BLK];
   FILE *fs;
#define WHOIS_MAX 3
   char *whois_ip[WHOIS_MAX] = {
      "192.149.252.21",		/* 0 - whois.arin.net  */
      "203.37.255.97",		/* 1 - whois.apnic.net */
      "193.0.0.200"		/* 2 - joshua.ripe.net */
   };

   int whois_style[WHOIS_MAX] = {
      US_STYLE,
      UK_STYLE,
      UK_STYLE
   };

   bzero (&sa, SO (sa));
   sa.sin_family = AF_INET;
   sa.sin_port = htons (43);

   for (j = 0; j != -1;) {
      sa.sin_addr.s_addr = inet_addr (whois_ip[j]);
      if ((sd = socket (AF_INET, SOCK_STREAM, 0)) < 0)
	 FAILED ("socket()");
      if (connect (sd, (SA *) & sa, SO (sa)) < 0)
	 FAILED ("connect()");

      sprintf (string, "%s\r\n", inet_ntoa (ipaddr));

      if (write (sd, string, strlen (string) + 1) != strlen (string) + 1) {
	 close (sd);
	 FAILED ("write()");
      }
      for (i = 5; i; i--) {
	 if ((fs = tmpfile ()))
	    break;
	 sleep (1);
      }

      if (!fs) {
	 close (sd);
	 FAILED ("tmpfile()");
      }
      while ((i = read (sd, buf, SO (buf) - 1)) > 0)
	 fwrite (buf, i, 1, fs);

      close (sd);

      rewind (fs);
      fgets (buf, SO (buf), fs);
      rewind (fs);

      (whois_style[j] == US_STYLE ? us_style : uk_style) (gp, fs);

      if (strstr (buf, "APNIC"))
	 j = 1;
      else if (strstr (buf, "RIPE"))
	 j = 2;
      else
	 j = -1;

      fclose (fs);
      fs = NULL;
   }

   return (0);
}

/* ripe.net whois reply style parsing */
int
uk_style (S geo * gp, FILE * fp)
{
   char line[160], *sp;

   bzero (gp, sizeof (S geo));

   while (fgets (line, SO (line), fp))
      if (!strncmp (line, "inetnum:", 8))
	 break;

   if (feof (fp))
      return (-1);

   while (fgets (line, SO (line), fp)) {
      if (!strncmp (line, "country:", 8) && !*gp->country)
	 if (strlen (sp = rmspace (line + 8)) == 2)
	    strcpy (gp->country, sp);
      if (!strncmp (line, "descr:", 6) && !*gp->name)
	 strncpy (gp->name, rmspace (line + 8), GLNAM - 1);
      if (!strncmp (line, "address:", 8))
	 strncpy (gp->location, rmspace (line + 8), GLLOC - 1);
   }

   return (0);
}

/* arin.net whois reply style parsing */
int
us_style (S geo * gp, FILE * fp)
{
   char line[160], *sp;

   bzero (gp, sizeof (S geo));

   fgets (line, SO (line), fp);

   if (!strchr (line, '(') || !strchr (line, ')'))
      return (-1);

   strncpy (gp->name, rmspace (strtok (line, "(")), GLNAM - 1);

   do {
      sp = rmspace (fgets (line, SO (line), fp));
      if (!sp || !*sp)
	 break;
      if (strlen (sp) == 2)
	 strcpy (gp->country, sp);
      else
	 strncpy (gp->location, sp, GLLOC - 1);
   }
   while (strlen (sp) != 2);

   return (0);
}

/* remove whitespace in front and in rear of a string - volatile */
char *
rmspace (char *line)
{
   if (!line)
      return (NULL);
   while (isspace (lastchr (line)))
      lastchr (line) = '\0';
   while (isspace (*line++));
   return (line - 1);
}
