#include <sys/ioctl.h>
#include <sys/sockio.h>
#include <netinet/ip.h>
#include <net/if.h>
#include <net/route.h>
#include <pcap.h>
#include <netinet/ip_icmp.h>

#ifndef S
#define S struct
#endif

#define PMIN (64 + 2 * (sizeof(struct icmp) + sizeof(struct ip)))
#define CHK_SOURCE_IP 1
#define CHK_DEST_IP 0
#define IFR_MAX 10

#ifndef IFNAMSIZE
#define IFNAMSIZE 16
#endif

S rawifconf
{
   pcap_t *ri_pd;		/* libpcap descriptor */
   char ri_if[IFNAMSIZE];	/* interface device name */
   int ri_sd,			/* icmp socket descriptor */
     ri_off;			/* interface frame offset */
   S in_addr ri_src,		/* interface ip */
     ri_dst;			/* target ip */
};

extern int addr2ifname (char *, struct in_addr);
extern int ifname2addr (struct in_addr *, char *);
extern int get_packet (S rawifconf *, S ip *, char *, int, int);
extern int init_packet_devices (S rawifconf *);
extern void term_packet_devices (S rawifconf *);
extern int sendicmp (S rawifconf *, u_char, u_char, u_short, u_char);
